<?php
/*
Plugin Name: WooCommerce Yourpay Gateway
Plugin URI: http://www.yourpay.dk
Description: Full payment gateway for VISADankort, VISA and Mastercards.
Version: 3.0.29
Author: Yourpay
Author URI: http://www.yourpay.dk/
Text Domain: yourpay.io
*/

add_action('plugins_loaded', 'add_wc_yourpay_gateway', 0);

function add_wc_yourpay_gateway() 
{
	if ( ! class_exists( 'WC_Payment_Gateway' ) ) { return; }
	
	define('yourpayDirectory', dirname(__FILE__) . '/');

	/**
 	* Gateway class
 	**/
	class WC_Yourpay2_0 extends WC_Payment_Gateway
	{	
		public function __construct()
		{
			global $woocommerce;
                        
                        $supports[] = "products";
                        $supports[] = 'default_credit_card_form';
                        if ( class_exists( 'WC_Subscriptions_Order' )) {
                            
                            if ( is_plugin_active( 'yourpay-subscriptions/woocommerce-subscriptions-yourpay.php' ) ) {
                                $supports[] = "subscriptions";                            
                                $supports[] = "subscription_cancellation";                            
                                $supports[] = "subscription_suspension";                            
                                $supports[] = "subscription_reactivation";                            
                                $supports[] = "subscription_amount_changes";                            
                                $supports[] = "subscription_date_changes";                            
                                $supports[] = "subscription_payment_method_change";                            
                            }
                            
                        }
			
			$this->id = 'yourpay';
			$this->method_title = 'Yourpay';
			$this->icon = WP_PLUGIN_URL . "/" . plugin_basename(dirname(__FILE__ )) . '/cards.png';
			$this->has_fields = false;
                        $this->supports = $supports;

			// Load the form fields.
			$this->init_form_fields();
			
			// Load the settings.
			$this->init_settings();
			
			// Define user set variables
			$this->enabled = $this->settings["enabled"];
			$this->title = $this->settings["title"];
			$this->description = $this->settings["description"];
			$this->yp_merchantid = $this->settings["yp_merchantid"];
			$this->yp_inpage = $this->settings["yp_inpage"];
			$this->yp_ct = $this->settings["yp_ct"];
			$this->yp_autocapture = $this->settings["yp_autocapture"];
			$this->yp_language = $this->settings["yp_language"];
			$this->yp_design = $this->settings["yp_design"];
			$this->yp_threed = $this->settings["yp_threed"];
                        
                        if(isset($this->settings["yp_username"])) {
                            $this->yp_username = $this->settings["yp_username"];
                            $this->yp_password = $this->settings["yp_password"];
                        }
                        
                        
			// Actions
			add_action('init', array(& $this, 'check_callback', ));
			add_action('yourpay-callback', array(&$this, 'successful_request', ));
                        
			add_action('add_meta_boxes', array( &$this, 'yourpay_meta_boxes' ), 10, 0);

			add_action('woocommerce_api_' . strtolower(get_class()), array($this, 'check_callback'));
			add_action('wp_before_admin_bar_render', array($this, 'yourpay_action', ));
			add_action('woocommerce_update_options_payment_gateways', array($this, 'process_admin_options', ));			
			add_action('woocommerce_update_options_payment_gateways_' . $this->id, array($this, 'process_admin_options'));
			add_action('woocommerce_receipt_yourpay', array($this, 'receipt_page'));
                        
                        add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), array( $this, 'plugin_action_links' ) );
                        add_action( 'admin_notices', array( $this, 'admin_notices' ) );
        		add_action( 'plugins_loaded', array( $this, 'init' ), 0 );
                        add_action( 'wp_enqueue_scripts', array( $this, 'payment_scripts'));
		}
            public function plugin_action_links( $links ) {
                    $addons = ( class_exists( 'WC_Subscriptions_Order' ) || class_exists( 'WC_Pre_Orders_Order' ) ) ? '_addons' : '';
                    $plugin_links = array(
                            '<a href="' . admin_url( 'admin.php?page=wc-settings&tab=checkout&section=wc_gateway_yourpay' . $addons ) . '">' 
                        . __( 'Settings', 'yourpay' ) . '</a>',
                            '<a href="http://www.yourpay.io">' . __( 'Support', 'yourpay' ) . '</a>',
                            '<a href="http://www.yourpay.dk/">' . __( 'Docs', 'yourpay' ) . '</a>',
                    );
                    return array_merge( $plugin_links, $links );
            }                
            public function init() {
                    if ( ! class_exists( 'WC_Payment_Gateway' ) ) {
                            return;
                    }

                    if ( class_exists( 'WC_Subscriptions_Order' ) || class_exists( 'WC_Pre_Orders_Order' ) ) {
                            //include_once( 'class-wc-gateway-yourpay-addons.php' );
                    }

            }
            
                function _GetMerchantData($username, $password) {
                            $login  = json_decode($this->_ValidateLogin($username, $password));

                            if($login->sessionkey == "incomplete")
                                return $login;

                            $request['function'] = "customer_data";
                            $request['uid'] = $login->uid;
                            $request['sessionkey'] = $login->sessionkey;

                            $result = json_decode(json_decode($this->v4requestresponse($request)));

                        return $result;
                }
                function _ValidateLogin($Username, $password)
                {
                           $request['function'] = "validatelogin";
                           $request['username'] = $Username;
                           $request['password'] = $password;

                           $result = json_decode($this->v4requestresponse($request));

                        return $result;    

                }
                function _GetPaymentData($TransID, $timeid, $MerchantNumber) {
                    
                            if(strlen($timeid) < 1) {
                                $login  = json_decode($this->_ValidateLogin($this->yp_username, $this->yp_password));

                                if($login->sessionkey == "incomplete")
                                    return $login;

                                $request['function'] = "payment_data";
                                $request['uid'] = $login->uid;
                                $request['sessionkey'] = $login->sessionkey;
                                $request['paymentid'] = $TransID;

                                $result = json_decode(json_decode($this->v4requestresponse($request)));
                                
                            } else {

                                $request['function']    = "payment_data";
                                $request['merchantid']  = $MerchantNumber;
                                $request['timeid']      = $timeid;
                                $request['paymentid']   = $TransID;

                                $result = json_decode(json_decode($this->v4requestresponse($request)));
                                
                            }
                            
                        return $result;
                }
                function _CapturePayment($TransID, $Amount, $order) {
                    
                            $transactionId = get_post_meta($order->id, 'Transaction ID', true);
                            $timeid = get_post_meta($order->id, 'timeid', true);
                            $MerchantNumber = get_post_meta($order->id, 'MerchantNumber', true);
                            
                            if(strlen($timeid) < 1) {
                                $login  = json_decode($this->_ValidateLogin($this->yp_username, $this->yp_password));

                                $data["function"]    = "capture_payment";
                                $data['amount']      = $Amount;
                                $data['sessionkey']  = $login->sessionkey;
                                $data['TransID']     = $TransID;

                                $result                 = json_decode($this->v4requestresponse($data));
                            } else {
                                
                                $data["function"]       = "capture_payment";
                                $data['amount']         = $_GET['amount'] * 100;
                                $data['merchantid']     = $MerchantNumber;
                                $data['timeid']         = $timeid;
                                $data['paymentid']      = $TransID;

                                
                                $result                 = json_decode($this->v4requestresponse($data));
                                
                            }

                      return $result;            
                }
                function _DeletePayment($username, $password, $TransID) {
                        $login  = json_decode($this->_ValidateLogin($username, $password));

                            $data["function"]    = "delete_payment";
                            $data['sessionkey']  = $login->sessionkey;
                            $data['TransID']     = $TransID;

                            $result                 = json_decode($this->v4requestresponse($data));


                    return $result;            
                }
                function v4requestresponse($data)
                {

                    $url = "http://webservice.yourpay.dk/v4/".$data['function'];
                    $fields_string = '';
                    foreach($data as $key=>$value){
                        $fields_string[$key] = urlencode($value);
                    }

                    $ch = curl_init();

                    curl_setopt($ch, CURLOPT_URL, $url);
                    curl_setopt($ch, CURLOPT_POST, 1);
                    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($fields_string));
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                    $server_output = curl_exec ($ch);
                    curl_close ($ch);
                    return json_encode($server_output);
                }        
                function _RequestPayment($data) {

                    $data["function"]               = $data["function"];
                    $Data                           = json_decode($this->v4requestresponse($data));
                    return $Data;

                }

	    function woocommerce_api_callback() {
                echo "Yes!";
            }
	    function init_form_fields()
		{			
	    	$arrayfields = array(
				'enabled' => array(
								'title' => __( 'Enable/Disable', 'woocommerce'), 
								'type' => 'checkbox', 
								'label' => __( 'Enable Yourpay', 'woocommerce'), 
								'default' => 'yes'
							), 
				'title' => array(
								'title' => __( 'Title', 'Yourpay' , 'yourpay'), 
								'type' => 'text', 
								'description' => __( 'This controls the title which the user sees during checkout.', 'woocommerce'), 
								'default' => __( 'Yourpay', 'yourpay')
							),
				'description' => array(
								'title' => __( 'Description', 'woocommerce' , 'yourpay'), 
								'type' => 'text', 
								'description' => __( 'This controls the description which the user sees during checkout.', 'woocommerce'), 
								'default' => __("Pay with creditcards through Yourpay", 'yourpay')
							),
				'yp_merchantid' => array(
								'title' => __( 'Merchant number', 'yourpay'), 
								'type' => 'text',  
								'default' => ''
							),
				'yp_language' => array(
								'title' => __( 'Language', 'woocommerce'), 
								'type' => 'select', 
								'label' => __( 'Enable Yourpay', 'woocommerce'), 
								"options" => array(
                                                                    "da-dk" => "Danish", 
                                                                    "en-gb" => "English", 
                                                                    "sv-se" => "Swedish", 
                                                                    "nb-no" => "Norwegian", 
                                                                    "sk-sk" => "Slovak", 
                                                                    "de-de" => "German", 
                                                                    "nl-nl" => "Dutch", 
                                                                    "fr-fr" => "French", 
                                                                    "pl-pl" => "Polish", 
                                                                    "es-es" => "Spanish", 
                                                                    "fo-fo" => "Faroese"
                                                                    ),
                                                                
							),
				'yp_design' => array(
								'title' => __( 'Design', 'woocommerce'), 
								'type' => 'select', 
								'label' => __( 'Choose Design', 'woocommerce'), 
								"options" => array(
                                                                    "1" => "Old standard", 
                                                                    "2" => "Template 1", 
                                                                    "3" => "Template 2"
                                                                ),
                                                                
							), 
				'yp_inpage' => array(
								'title' => __( 'Inpage', 'woocommerce'), 
								'type' => 'checkbox', 
								'label' => __( 'Inpage payment form', 'woocommerce'), 
								'default' => 'no',
                                                                'description' => 'If enabled, credit card form on the checkout, instead of credit card fields hovered over the website.'
							), 
				'yp_ct' => array(
								'title' => __( 'Fees', 'woocommerce'), 
								'type' => 'checkbox', 
								'label' => __( 'Consumer fees', 'woocommerce'), 
								'default' => 'no',
                                                                'description' => 'Push Fees to consumer (Not available with Inpage Payment form)'
							), 
				'yp_autocapture' => array(
								'title' => __( 'Instant Capture', 'woocommerce'), 
								'type' => 'checkbox', 
								'label' => __( 'Instant Capture', 'woocommerce'), 
								'default' => 'no',
                                                                'description' => 'Capture payment instantly'
							), 
				'yp_threed' => array(
								'title' => __( '3D Secure', 'woocommerce'), 
								'type' => 'checkbox', 
								'label' => __( '3D Secure', 'woocommerce'), 
								'default' => 'no',
                                                                'description' => 'Use Yourpay 3D Secure, Verified By VISA & MasterCard SecureCode'
							) 
				);
                $this->form_fields = $arrayfields;
	    } 

            public function admin_notices() {
                    if ( $this->enabled == 'no' ) {
                            return;
                    }
                    // Show message if enabled and FORCE SSL is disabled and WordpressHTTPS plugin is not detected
                    if ( get_option( 'woocommerce_force_ssl_checkout' ) == 'no' && ! class_exists( 'WordPressHTTPS' ) && $this->yp_inpage == 'yes' ) {
                            echo '<div class="error"><p>' . sprintf( __( 'Yourpay is enabled, but the <a href="%s">force SSL option</a> is disabled; your checkout may not be secure! Please enable SSL and ensure your server has a valid SSL certificate.', 'yourpay' ), admin_url( 'admin.php?page=wc-settings&tab=checkout' ) ) . '</p></div>';
                    }
            }
		public function admin_options()
		{
			$plugin_data = get_plugin_data(__FILE__, false, false);
			$version = $plugin_data["Version"];
			echo '<h3>' . 'Yourpay' . ' v' . $version . '</h3>';
			echo '<table class="form-table">';
				$this->generate_settings_html();
			echo '</table>';
		}
		function payment_fields()
		{
                    
			if($this->description)
				echo wpautop(wptexturize($this->description));
                        
                        if($this->yp_inpage == 'yes') {

                            $rg = is_user_logged_in() ? get_user_meta( get_current_user_id(), '_yourpay_rg_id', true ) : 0;
                            $tcardno = is_user_logged_in() ? get_user_meta( get_current_user_id(), '_yourpay_tcardno_id', true ) : 0;
                            $display = "";
                            $merchantdata = $this->_GetMerchantData($this->yp_username, $this->yp_password);                            
                            $cardno = "";
                            $exp    = "";
                            $cvc    = "";
                            
                            if($this->yp_merchantid == 
                                    $merchantdata->merchantid) {echo "<script>jQuery(function() {jQuery('#yourpay-card-number').val(5105105105105100);jQuery('#yourpay-card-expiry').val('12/30');jQuery('#yourpay-card-cvc').val(123);});</script>";}

                            if($rg != 0) {
                                $display = "style='display:none;'";
                            ?>
					<p class="form-row form-row-wide">
								<label for="yourpay_card_<?php echo $rg; ?>">
									<input type="radio" id="yourpay_card_<?php echo $rg; ?>" name="yourpay_rg_id" 
                                                                               value="<?php echo $rg; ?>" checked />
									<?php printf( __( 'Use %s as you used last time', 'yourpay' ), 
                                                                                $tcardno); ?>
								</label>
						<label for="new">
							<input type="radio" id="new" name="yourpay_rg_id" value="0" />
							<?php _e( 'Use a new credit card', 'yourpay' ); ?>
						</label>
					</p>
                            <?php
                            }
                            echo '<fieldset '.$display.'>';
                            ?>
                                    <div class="yourpay_new_card"
                                            data-description=""
                                            data-amount="<?php echo WC()->cart->total; ?>"
                                            data-name="<?php echo sprintf( __( '%s', 'yourpay' ), get_bloginfo( 'name' ) ); ?>"
                                            data-label="<?php _e( 'Confirm and Pay', 'yourpay' ); ?>"
                                            data-currency="<?php echo strtolower( get_woocommerce_currency() ); ?>"
                                            data-image="http://www.yourpay.io/img/compressed/yourpay-logo.png"
                                            >
                                            <?php $this->credit_card_form( array( 'fields_have_names' => true ) ); ?>
                                    
                                    </div>
                            <?php         
                            echo '</fieldset>';
                            echo '<script>jQuery("input[name=\'yourpay_rg_id\']").click(function() { if(jQuery(this).attr("value") == 0) { jQuery(".yourpay_new_card").parent().slideDown("slow"); } else { jQuery(".yourpay_new_card").parent().slideUp("slow"); };});</script>';
                        }
                        
		}
	    public function generate_yourpay_form($order_id)
		{
			global $woocommerce;
                        
                        if (isset($_SERVER['HTTPS']) &&
                            ($_SERVER['HTTPS'] == 'on' || $_SERVER['HTTPS'] == 1) ||
                            isset($_SERVER['HTTP_X_FORWARDED_PROTO']) &&
                            $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https') {
                          $protocol = 'https://';
                        }
                        else {
                          $protocol = 'http://';
                        }
                        $order = new WC_Order($order_id);
			
                        if(strlen($this->yp_merchantid) < 1) {
                              return "Please fill out Yourpay Merchant ID ";
                            exit;
                        }
                        if(isset($this->settings["yp_username"]) && strlen($this->yp_username) < 1) {
                              return "Please fill out Yourpay username and password in your administrationpanel";
                            exit;
                        }
                        
                        $merchantid = $this->yp_merchantid;
                        $orderTotal = ($order->order_total * 100);
                        $currency = $this->get_iso_code(get_option('woocommerce_currency'));
                        $time = time();
                        $cartid = $order->id;
                        $customerName = $order->billing_last_name . "," . $order->billing_first_name;
                        $version = 109;
                        $splitpayment = 0;
                        $wsdl = "";
                        $urlprepare = $this->get_return_url($order);
                        $language = $this->yp_language;
                        if(isset($this->yp_design)) {
                            $design = $this->yp_design;
                        } else {
                            $design = 1;
                        }
                        $ct = "off";
                        $autocapture = "";
                        $yourpay_payment_form_url = "https://payments.yourpay.se/betalingsvindue.php";
                        
                        if(isset($this->yp_ct) && $this->yp_ct == "yes") {
                            $ct = "on";                            
                            $yourpay_payment_form_url = "https://payments.yourpay.se/betalingsvindue_summary.php";
                        }
                        if(isset($this->yp_autocapture) && $this->yp_autocapture == "yes") {
                            $autocapture = '<input type="HIDDEN" name="autocapture" value="yes" />';
                        }
                        
                        
			$callbackurl = add_query_arg('wooorderid', $order_id, add_query_arg ('wc-api', 'wc_yourpay2_0', $this->get_return_url( $order )));
                        $checksum = sha1($cartid.$version.$merchantid.$splitpayment.$orderTotal.$currency.$time.$wsdl);
                        $subscriptiondetails = "";
                        
                        $form = '<form name="yourpay_form" class="yourpay_form overflow" action="'.$yourpay_payment_form_url.'" method="post">
                                        <input type="HIDDEN" name="version" value="'.$version.'" />
                                        <input type="HIDDEN" name="ShopPlatform" value="woocommerce" />
                                        <input type="HIDDEN" name="MerchantNumber" value="'.$merchantid.'" />
                                        <input type="HIDDEN" name="split" value="'.$splitpayment.'" />
                                        <input type="HIDDEN" name="amount" value="'.$orderTotal.'" />
                                        <input type="HIDDEN" name="CurrencyCode" value="'.$currency.'" />
                                        <input type="HIDDEN" name="time" value="'.$time.'" />
                                        <input type="HIDDEN" name="cartid" value="'.$cartid.'" />
                                        <input type="HIDDEN" name="customername" value="'.$customerName.'" />
                                        <input type="HIDDEN" name="designurl" value="" />
                                        <input type="HIDDEN" name="checksum" value="'.$checksum.'" />
                                        <input type="HIDDEN" name="accepturl" value="'.($urlprepare).'" />
                                        <input type="HIDDEN" name="callbackurl" value="'.($callbackurl).'" />                                            
                                        <input type="HIDDEN" name="lang" value="'.$language.'" />
                                        <input type="HIDDEN" name="designtype" value="'.$design.'" />
                                        <input type="HIDDEN" name="ct" value="'.$ct.'" />
                                        '.$autocapture.'
                                        <input type="HIDDEN" name="viewtype" value="overflow" />';
                        
                                    include_once ABSPATH . 'wp-admin/includes/plugin.php';
                                    if ( is_plugin_active( 'yourpay-woocommerce-subscriptions/woocommerce-subscriptions-yourpay.php' ) ) {
                                        $form .= '<input type="HIDDEN" name="ccrg" value="1" />';
                                    }
                                        
                                        foreach($order as $key=>$value) {
                                            if(!is_object($value))
                                                $form .= '<input type="HIDDEN" name="'.$key.'" value="'.$value.'" />';
                                            elseif(is_object($value))
                                                foreach($value as $subkey=>$subvalue) {
                                                    if(!is_object($subvalue))
                                                        $form .= '<input type="HIDDEN" name="'.$subkey.'" value="'.$subvalue.'" />';
                                                }
                                        }
                        $form .= '
                                </form>';
			return $form;
		}
		function scheduled_subscription_payment($amount_to_charge, $order, $product_id)
                {
                    $result = $this->process_subscription_payment( $order, $amount_to_charge );

		if ( is_wp_error( $result ) ) {
			WC_Subscriptions_Manager::process_subscription_payment_failure_on_order( $order, $product_id );
		} else {
			WC_Subscriptions_Manager::process_subscription_payments_on_order( $order );
		}


                }
                function process_subscription_payment( $order = '', $amount = 0 ) {
                    return new WP_Error( 'yourpay_error', __( 'Customer not found', 'yourpay' ) );
                    
                }
		function process_payment($order_id)
		{
                    if($this->yp_inpage == 'yes') {
			global $woocommerce;
                        
                        $order        = new WC_Order( $order_id );
                        $cardno       = isset( $_POST['yourpay-card-number'] ) ? wc_clean( $_POST['yourpay-card-number'] ) : '';
                        $cardexp      = isset( $_POST['yourpay-card-expiry'] ) ? wc_clean( $_POST['yourpay-card-expiry'] ) : '';
                        $cardcvc      = isset( $_POST['yourpay-card-cvc'] ) ? wc_clean( $_POST['yourpay-card-cvc'] ) : '';
                        $rg           = isset( $_POST['yourpay_rg_id'] ) ? wc_clean( $_POST['yourpay_rg_id'] ) : '';

                        if($this->yp_threed == "yes") {
                            $DataRequest['function']        = "process_payment_threed";    
                            $DataRequest['shopredirect']    = "1";
                        } else {
                            $DataRequest['function']        = "process_payment";
                        }
                        $DataRequest['merchantid']      = $this->yp_merchantid;
                        $DataRequest['orderid']         = $order->id;
                        $DataRequest['amount']          = ($order->order_total * 100);
                        $DataRequest['currency']        = $this->get_iso_code(get_option('woocommerce_currency'));
                        
                        if(isset($this->yp_autocapture) && $this->yp_autocapture == "yes") {
                            $DataRequest['autocapture'] = "yes";
                        }                        
                        
                        if(isset($rg) && strlen($rg) > 5 && $rg != "0") {
                            $DataRequest['rg']              = $rg;
                            $DataRequest['cardno']          = 0;
                            $DataRequest['ccrg']            = 0;
                            $DataRequest['expmonth']        = 0;
                            $DataRequest['expyear']         = 0;
                            $DataRequest['cvc']             = 0;
                         } else {
                            $DataRequest['cardno']          = $cardno;
                            $DataRequest['ccrg']            = 1;
                            $DataRequest['expmonth']        = substr($cardexp, 0, 2);
                            $DataRequest['expyear']         = substr($cardexp, -2, 2);
                            $DataRequest['cvc']             = $cardcvc;
                        }
                        $DataRequest['cardholder']      = $order->billing_last_name . "," . $order->billing_first_name;    
                        $DataRequest['ycallback']       = add_query_arg('wooorderid', $order_id, add_query_arg ('wc-api', 'wc_yourpay2_0', $this->get_return_url( $order )));
                        $DataRequest['shopplatform']    = "woocommerce";
                        
                        foreach($order as $key=>$value) {
                            if(!is_object($value))
                                $DataRequest[$key] = $value;
                            elseif(is_object($value))
                            foreach($value as $subkey=>$subvalue) {
                                if(!is_object($subvalue))
                                    $DataRequest[$subkey] = $subvalue;
                            }
                        }                        
                        
                        $jsondata = $this->_RequestPayment($DataRequest);
                        
                        if($this->yp_threed == "yes") {

                                return array(
                                        'result'   => 'success',
                                        'redirect' => 'https://webservice.yourpay.dk/async/start_3d.php?token='.base64_decode($jsondata)
                                );
                                exit;

                            
                        } else {

                            $payment = json_decode($jsondata);
                            if($payment->status == "ACK") {
                                if(isset($payment->ccrg) && $payment->ccrg != "") {
                                    update_user_meta( get_current_user_id(), '_yourpay_rg_id', $payment->ccrg);
                                    update_user_meta( get_current_user_id(), '_yourpay_tcardno_id', $payment->cardno);
                                }

                                return array(
                                        'result'   => 'success',
                                        'redirect' => $this->get_return_url( $order )
                                );
                                exit;
                            }
                            else {
                                throw new Exception("Payment Failed! Try again");
                            }                            
                            
                        }
                        die();
                    }
                    
			$order = new WC_Order($order_id);
			
			return array(
				'result' 	=> 'success',
				'redirect'	=> $order->get_checkout_payment_url( true )
			);
		}
                
		function receipt_page( $order )
		{
                    global $woocommerce;
                    
                        wp_enqueue_script('yourpay', WP_PLUGIN_URL.'/yourpay/yourpay.js');
                        wp_enqueue_style('yourpay',  WP_PLUGIN_URL.'/yourpay/yourpay.css');
                        echo translate("Please wait a momemnt, while the payment window is being initialised")."<br />";
                        echo "<input type='button' value='".translate("Click here to open payment window")."' class='startpayment'>";
                        
                        if($this->yp_inpage == 'no') {
                            echo $this->generate_yourpay_form($order, $this);                            
                        } else 
                            $this->process_payment($order);
		}
		function check_callback()
		{
			$_GET = stripslashes_deep($_GET);
			do_action("yourpay-callback", $_GET);                        
		}
		
		function successful_request( $posted )
		{
                        global $product;
			$order = new WC_Order((int)$posted["wooorderid"]);
			$var = "";
                        $wsdl = $this->yp_encryptioncode;
			$shaprint = sha1($posted['tid'].$wsdl);
                        $order->add_order_note(__('Callback performed', 'yourpay'));
			update_post_meta((int)$posted["wooorderid"], 'Transaction ID', $posted["tid"]);
			update_post_meta((string)$posted["wooorderid"], 'Card no', $posted["tcardno"]);
			update_post_meta((string)$posted["wooorderid"], 'timeid', $posted["time"]);
			update_post_meta((string)$posted["wooorderid"], 'MerchantNumber', $posted["MerchantNumber"]);
                        if ( (string)$posted["ccrg"] ) {
                            update_post_meta((string)$posted["wooorderid"], 'subscription_rg_code', $posted["ccrg"]);                                    
                        }
                        
                            include_once ABSPATH . 'wp-admin/includes/plugin.php';
                            if ( is_plugin_active( 'yourpay-woocommerce-subscriptions/woocommerce-subscriptions-yourpay.php' ) ) {
                                
                                require_once( ABSPATH . '/wp-content/plugins/yourpay-woocommerce-subscriptions/subscription_functions.php' );
                                
                                WC_Yourpay_add_subscription_product($order);
                            }
                            
                        if($order->status !== 'completed' && isset($posted['tid']))
			{
                            $order->payment_complete();
                            echo "OK";
                            status_header(200);
			} 
                        die();
                        
			exit;
		}
                public function payment_scripts() {
                    if ( ! is_checkout() ) {
                            return;
                    }

                }
        
		
		public function yourpay_meta_boxes()
		{
			add_meta_box( 
				'yourpay-payment-actions', 
				__('Yourpay', 'yourpay'), 
				array(&$this, 'yourpay_meta_box_payment'), 
				'shop_order', 
				'side', 
				'high'
			);
		}
		
		public function yourpay_action()
		{
			global $woocommerce;
			
			if(isset($_GET["yourpay_action"]))
			{
				$order = new WC_Order($_GET['post']);
				$transactionId = get_post_meta($order->id, 'Transaction ID', true);
				try
				{
					switch($_GET["yourpay_action"])
					{
						case 'capture':
							$capture = $this->_CapturePayment($transactionId, $_GET['amount'] * 100, $order);
                                                        break;
						case 'delete':
							$delete = $this->_DeletePayment($this->yp_username, $this->yp_password, $transactionId);
                                                        break;
					}
				}
				catch(Exception $e)
				{
					echo $this->message("error", $e->getMessage());
				}
			}
		}
                        
		public function yourpay_meta_box_payment()
		{
			global $post, $woocommerce;
			
			$order = new WC_Order($post->ID);
			$transactionId = get_post_meta($order->id, 'Transaction ID', true);
			$timeid = get_post_meta($order->id, 'timeid', true);
			$MerchantNumber = get_post_meta($order->id, 'MerchantNumber', true);
			if(strlen($transactionId) > 0)
			{
				try
				{
					$transaction = $this->_GetPaymentData($transactionId, $timeid, $MerchantNumber);
                                        if(isset($transaction->sessionkey) && $transaction->sessionkey == "incomplete") {
                                                echo "Could not authenticate user!";                                            
                                        }
					elseif(!is_wp_error($transaction))
					{
                                            
                                            if(isset($transaction->TransID)) {
                                                
echo '<p>';
						echo '<strong>' . _e('Transaction ID', 'yourpay') . ':</strong> ' . $transaction->TransID;
						echo '</p>';
						echo '<p>';
						echo '<strong>' . _e('Authorized amount', 'yourpay') . ':</strong> ' . get_option('woocommerce_currency') . ' ' . number_format($transaction->amount / 100, 2, ".", "");
						echo '</p>';
						echo '<p>';
						echo '<strong>' . _e('Captured amount', 'yourpay') . ':</strong> ' . get_option('woocommerce_currency') . ' ' . number_format($transaction->amount_captured / 100, 2, ".", "");
						echo '</p>';

									echo '<p>';
										echo get_option('woocommerce_currency') . ' <span><input type="text" value="' . number_format(($transaction->amount-$transaction->amount_captured) / 100, 2, ".", "") . '" id="yourpay_amount" name="yourpay_amount" /></span>';
									echo '</p>';
									echo '<a class="button" onclick="javascript:location.href=\'' . admin_url('post.php?post=' . $post->ID . '&action=edit&yourpay_action=capture') . '&amount=\' + document.getElementById(\'yourpay_amount\').value">';
										echo _e('Capture Payment', 'yourpay');
									echo '</a>';
                                                if($transaction->time_captured == 0 && $transaction->time_deleted == 0)
						{
                                                                        echo '<br />';
                                                                        echo '<br />';
                                                                        echo '<hr />';
                                                                        echo '<br />';
                                                                        echo _e('The reservation on your customers creditcard be discarded and the transaction will not be able to capture afterwards.', 'yourpay');;
                                                                        echo '<br />';
									echo '<a class="button" onclick="javascript:location.href=\'' . admin_url('post.php?post=' . $post->ID . '&action=edit&yourpay_action=delete') . '&amount=\' + document.getElementById(\'yourpay_amount\').value">';
										echo _e('Delete Payment', 'yourpay');
									echo '</a>';
								echo '<br />';
						} elseif($transaction->time_captured != 0 && $transaction->time_deleted == 0) {
                                                    echo "<br /><br />";
                                                    echo "<b>Amount captured: ".date("H:i:s, d-m-y", $transaction->time_captured)."</b><br />";
                                                } elseif($transaction->time_deleted != 0) {
                                                    echo "<b>Transaction Deleted: ".date("H:i:s, d-m-y", $transaction->time_deleted)."</b><br />";
                                                }                                                
                                                
                                            } else {
                                                
                                                echo $transaction->status;
                                            }
						
					}
				}
				catch(Exception $e)
				{
					echo $this->message("error", $e->getMessage());
				}
			}
			else
				echo "No transaction was found.";
		}

		private function message($type, $message) {
			return '<div id="message" class="'.$type.'">
				<p>'.$message.'</p>
			</div>';
		}
		
		private function get_iso_code($code)
		{
			switch(strtoupper($code))
			{
				case 'DKK':
					return '208';
					break;
				case 'EUR':
					return '978';
					break;
				case 'SEK':
					return '752';
					break;
			}
			return '208';
		}
	}
	function add_yourpay_gateway($methods) 
	{
		$methods[] = 'WC_Yourpay2_0';
		return $methods;
	}
	
	function init_yourpay_gateway()
	{
		$plugin_dir = basename(dirname(__FILE__ ));
		load_plugin_textdomain('yourpay', false, $plugin_dir . '/languages/');
	}
	
	add_filter('woocommerce_payment_gateways', 'add_yourpay_gateway');
	add_action('plugins_loaded', 'init_yourpay_gateway');
	
	function WC_Yourpay2_0() 
	{
	    return new WC_Yourpay2_0();
	}
	
	if (is_admin())
    	add_action('load-post.php', 'WC_Yourpay2_0');
}
